#pragma semicolon 1
#include <sourcemod>

public Plugin:myinfo = 
{
	name	= "Connect History",
	author	= "wS (World-Source.Ru)",
	version = "1.1"
};

new Handle:g_hSQL;
new g_Day;

public OnPluginStart()
{
	decl String:Info[256];

	if ((g_hSQL = SQLite_UseDatabase("connect_history", Info, 256)) == INVALID_HANDLE)
		SetFailState(Info);

	SQL_TQuery(g_hSQL, SQL_CallBack, "CREATE TABLE IF NOT EXISTS `connect_history` (\
		`name` TEXT NOT NULL, \
		`steamid` TEXT NOT NULL, \
		`ip` TEXT NOT NULL, \
		`date` TEXT NOT NULL, \
		PRIMARY KEY (`steamid`))", _, DBPrio_High);

	decl String:cur_day[25];
	FormatTime(cur_day, 25, "%d");
	g_Day = StringToInt(cur_day);

	wS_SaveHistory();
	CreateTimer(10.0, wS_TrySaveHistory, _, TIMER_REPEAT);

	RegConsoleCmd("sm_ch", ch_cmd);
	RegAdminCmd("sm_ch_dump", ch_dump_cmd,  ADMFLAG_ROOT);
}

public SQL_CallBack(Handle:hSql, Handle:hResult, const String:error[], any:ata)
{
	if (hResult == INVALID_HANDLE) LogError(error);
}

public SQL_SaveHistory(Handle:hSql, Handle:hResult, const String:error[], any:pack)
{
	if (hResult == INVALID_HANDLE)
	{
		CloseHandle(pack);
		LogError(error);
		return;
	}

	if (SQL_GetRowCount(hResult) < 1)
	{
		CloseHandle(pack);
		return;
	}

	ResetPack(pack);
	new d = ReadPackCell(pack);
	new m = ReadPackCell(pack);
	new y = ReadPackCell(pack);
	new bool:bDump = ReadPackCell(pack) == 1;
	CloseHandle(pack);

	decl String:Info[256];
	CreateDirectory("cfg/connect_history", 511);
	Format(Info, 256, "cfg/connect_history/%d", y);
	CreateDirectory(Info, 511);
	Format(Info, 256, "%s/%d", Info, m);
	CreateDirectory(Info, 511);
	Format(Info, 256, "%s/%d%s.txt", Info, d, bDump ? "_dump" : "");

	new Handle:hFile = OpenFile(Info, "w");
	if (hFile == INVALID_HANDLE)
	{
		LogError("OpenFile error '%s'", Info);
		return;
	}

	new count = 0;
	decl String:name[35], String:steamid[65], String:ip[20], x;

	while (SQL_FetchRow(hResult))
	{
		SQL_FetchString(hResult, 0, name, 35);

		// `steamid` = STEAM_...|d.m.y
		SQL_FetchString(hResult, 1, steamid, 65);
		if ((x = FindCharInString(steamid, '|', true)) > -1) steamid[x] = '\0';

		SQL_FetchString(hResult, 2, ip, 20);

		if (++count == 1)
		{
			new const String:sMonth[][] = 
			{
				"Январь",
				"Февраль",
				"Март",
				"Апрель",
				"Май",
				"Июнь",
				"Июль",
				"Август",
				"Сентябрь",
				"Октябрь",
				"Ноябрь",
				"Декабрь"
			};
			WriteFileLine(hFile, "%02d / %02d (%s) / %d\n \n", d, m, sMonth[m-1], y);
		}

		WriteFileLine(hFile, "%04d. %s (%s, %s)", count, name, steamid, ip);
	}

	CloseHandle(hFile);
}

public Action:wS_TrySaveHistory(Handle:timer)
{
	decl String:cur_day[25];
	FormatTime(cur_day, 25, "%d");
	new d = StringToInt(cur_day);
	if (g_Day != d)
	{
		g_Day = d;
		wS_SaveHistory();
	}
	return Plugin_Continue;
}

wS_SaveHistory()
{
	decl String:cur_date[50], String:old_date[50], String:buffer[3][10], String:Info[256];

	FormatTime(cur_date, 50, "%d.%m.%Y");
	FormatTime(old_date, 50, "%d.%m.%Y", GetTime() - 86400);

	ExplodeString(old_date, ".", buffer, 3, 10);
	new d = StringToInt(buffer[0]);
	new m = StringToInt(buffer[1]);
	new y = StringToInt(buffer[2]);
	Format(Info, 256, "cfg/connect_history/%d/%d/%d.txt", y, m, d);
	if (!FileExists(Info))
	{
		new Handle:pack = CreateDataPack();
		WritePackCell(pack, d);
		WritePackCell(pack, m);
		WritePackCell(pack, y);
		WritePackCell(pack, 0);
		Format(Info, 256, "SELECT `name`, `steamid`, `ip` FROM `connect_history` WHERE `date` = '%s'", old_date);
		SQL_TQuery(g_hSQL, SQL_SaveHistory, Info, pack, DBPrio_High);
	}

	Format(Info, 256, "DELETE FROM `connect_history` WHERE `date` != '%s'", cur_date);
	SQL_TQuery(g_hSQL, SQL_CallBack, Info, _, DBPrio_High);

	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsValidEntity(i) && IsClientInGame(i))
			OnClientPutInServer(i);
	}
}

public OnClientPutInServer(client)
{
	if (IsFakeClient(client))
		return;

	decl String:steamid[65];
	if (!GetClientAuthString(client, steamid, 65))
		return;

	decl String:cur_date[50];
	FormatTime(cur_date, 50, "%d.%m.%Y");
	Format(steamid, 65, "%s|%s", steamid, cur_date);

	decl String:name[35];
	if (GetClientName(client, name, 35))
	{
		ReplaceString(name, 35, "\\", "");
		ReplaceString(name, 35, "'", "");
		ReplaceString(name, 35, "\"", "");
	}
	else
		name[0] = '-';

	decl String:ip[20];
	if (!GetClientIP(client, ip, 20)) ip[0] = '-';

	decl String:sQuery[350];
	Format(sQuery, 350, "INSERT OR IGNORE INTO `connect_history` (`name`, `steamid`, `ip`, `date`) VALUES ('%s', '%s', '%s', '%s')", name, steamid, ip, cur_date);
	SQL_TQuery(g_hSQL, SQL_CallBack, sQuery, _, DBPrio_Normal);
}

public Action:ch_cmd(admin, args)
{
	///
	static last_time[MAXPLAYERS + 1] = {0, ...};
	new curr_time = GetTime();
	if ((curr_time - last_time[admin]) < 10)
	{
		PrintToConsole(admin, "Попробуйте через %d сек", (10 - (curr_time - last_time[admin])));
		return Plugin_Handled;
	}
	last_time[admin] = curr_time;
	///

	if (admin > 0) admin = GetClientUserId(admin);
	decl String:cur_date[50],  String:sQuery[200];
	FormatTime(cur_date, 50, "%d.%m.%Y");
	Format(sQuery, 200, "SELECT count(*) FROM `connect_history` WHERE `date` = '%s'", cur_date);
	SQL_TQuery(g_hSQL, SQL_ch_cmd, sQuery, admin, DBPrio_High);

	return Plugin_Handled;
}

public SQL_ch_cmd(Handle:hSql, Handle:hResult, const String:error[], any:admin)
{
	if (admin > 0 && (admin = GetClientOfUserId(admin)) < 0) admin = 0;
	if (hResult == INVALID_HANDLE) PrintToConsole(admin, error);
	else PrintToConsole(admin, "Сегодня сервер посетило: %d чел", SQL_FetchInt(hResult, 0));
}

public Action:ch_dump_cmd(admin, args)
{
	///
	static last_time = 0;
	new curr_time = GetTime();
	if ((curr_time - last_time) < 10)
	{
		PrintToConsole(admin, "Попробуйте через %d сек", (10 - (curr_time - last_time)));
		return Plugin_Handled;
	}
	last_time = curr_time;
	///

	decl String:cur_date[50], String:buffer[3][10], String:Info[256];

	FormatTime(cur_date, 50, "%d.%m.%Y");
	ExplodeString(cur_date, ".", buffer, 3, 10);
	new d = StringToInt(buffer[0]);
	new m = StringToInt(buffer[1]);
	new y = StringToInt(buffer[2]);

	new Handle:pack = CreateDataPack();
	WritePackCell(pack, d);
	WritePackCell(pack, m);
	WritePackCell(pack, y);
	WritePackCell(pack, 1);
	Format(Info, 256, "SELECT `name`, `steamid`, `ip` FROM `connect_history` WHERE `date` = '%s'", cur_date);
	SQL_TQuery(g_hSQL, SQL_SaveHistory, Info, pack, DBPrio_High);

	PrintToConsole(admin, "cfg/connect_history/%d/%d/%d_dump.txt", y, m, d);
	return Plugin_Handled;
}